/** skkserv/skkdic.c --- rskkserv module for skkdic.

 * Copyright (C) 2000,2001  YAMASHITA Junji

 * Author:	YAMASHITA Junji <ysjj@unixuser.org>
 * Version:	0.9

 * This file is part of rskkserv.

 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
**/

#include <stdio.h>
#include <string.h>
#include <ruby.h>

static VALUE cSKKDic;

static VALUE fskkdic_s_search(VALUE self, VALUE kana, VALUE path, VALUE cache);

void Init_skkdic()
{
	cSKKDic = rb_define_class("SKKDic", rb_cObject);

	rb_define_singleton_method(cSKKDic, "search", fskkdic_s_search, 3);
}

#define FALSE 0
#define TRUE  1

static VALUE
fskkdic_s_search(VALUE self, VALUE vkana, VALUE path, VALUE cache)
{
  char *kana = STR2CSTR(vkana);
  int kana_len = strlen(kana);
  char buf[BUFSIZ];
  int pos, left, right;
  int found;
  FILE *jisyo_fp = fopen(STR2CSTR(path), "r");
  FILE *table_fp = fopen(STR2CSTR(cache), "r");
  VALUE retval = rb_ary_new();

  found = FALSE;
  left = 0;
  fseek(table_fp, 0, SEEK_END);
  right = (int)ftell(table_fp) / sizeof(int);
  while (left <= right) {
    int cmp, ofs;
    pos = (left + right) / 2;

    fseek(table_fp, pos * sizeof(int), SEEK_SET);
    fread(&ofs, sizeof(int), 1, table_fp);
    fseek(jisyo_fp, ofs, SEEK_SET);
    fgets(buf, sizeof(buf), jisyo_fp);
    cmp = strncmp(buf, kana, kana_len);
    if (cmp == 0) {
      found = TRUE;
      break;
    } else if (cmp > 0) {
      right = pos - 1;
    } else /* if (cmp < 0) */ {
      left = pos + 1;
    }
  }

  if (found) {
    char *p, *q;
    for (p = buf + kana_len + 1, q = p; *p != '\n'; p = q + 1) {
      while (*++q != '/')
	/* void */;
      rb_ary_push(retval, rb_str_new(p, q - p));
    }
  }

  fclose(jisyo_fp);
  fclose(table_fp);

  return retval;
}

/** ext/skkdic.c ends here **/
