### test/ebdic-wdic.rb -- unit test for ebdic module, using WDIC

## Author:	YAMASHITA Junji <ysjj@unixuser.org>

### Code:

require 'runit/testcase'

$stdout.sync = true

class EBDicWDicTest <RUNIT::TestCase
  def setup
    @ebdic = EBDic.new("/opt/epwing/wdic", "WDIC")
  end

  def test_search_failure
    assert(@ebdic.search("夲").empty?)
    assert(@ebdic.search("\001\001").empty?)
  end

  def test_search_success
    assert_equal("Ϥˤ㡼/Ϥˤ",
		 @ebdic.search("Ϥˤ㡼").join("/"))
  end

  def tear_down
  end
end

if __FILE__ == $0
  load 'rskkserv.conf'
  load 'skkserv/ebdic.rb'

  require 'runit/cui/testrunner'
  RUNIT::CUI::TestRunner.run(EBDicWDicTest.suite)
end

# test/ebdic-wdic.rb ends here
