### test/skkdic.rb -- unit test for skkdic module,
###		      using SKK-JISYO.L (v1.30 2000/12/07 12:11:23)

require "runit/testcase"

$stdout.sync = true

load "rskkserv.conf"
load "skkserv/skkdic.rb"

$jisyo = SKKServerConfig::SKKDic::DICFILE
$cachedir = SKKServerConfig::SKKDic::CACHEDIR
$nocache = SKKServerConfig::SKKDic::NOCACHE
$kcode = SKKServerConfig::SKKDic::KCODE

class SKKDicTest <RUNIT::TestCase
  def setup
    @skkdic = SKKDic.new($jisyo, $cachedir, $nocache, $kcode)
  end

  def test_lookup_okuru_ari_failure
    assert(@skkdic.search("ۤ").empty?)
  end

  def test_lookup_okuri_ari_success
    assert_equal(";;;ĥ", @skkdic.search("r").join(";"))
  end

  def test_lookup_okuri_ari_success_0
    assert_equal("", @skkdic.search("s").join(";"))
  end

  def test_lookup_okuri_ari_success_z
    assert_equal("", @skkdic.search("b").join(";"))
  end

  def test_lookup_okuru_nasi_failure
    assert(@skkdic.search("ۤr").empty?)
  end

  def test_lookup_okuri_nasi_success
    assert_equal(";;ʹ",
		 @skkdic.search("ޤ").join(";"))
  end

  def test_lookup_okuri_nasi_success_0
    assert_equal(";ò", @skkdic.search("!").join(";"))
  end

  def test_lookup_okuri_nasi_success_z
    assert_equal("", @skkdic.search("ƥ").join(";"))
  end

  def tear_down
  end
end

if __FILE__ == $0
  require "runit/cui/testrunner"
  RUNIT::CUI::TestRunner.run(SKKDicTest.suite)
end

### test/skkdic.rb ends here
